type DataInputStream = {
    with InputStream
    def readLine: string
    def readInt: int
    def readFloat: float
    def readUTF: string
}

newtype DataInputStreamModule = {
    def create(funnelstream: InputStream): DataInputStream
    def new(javastream: any): DataInputStream
    def extend(funnelstream: InputStream, javastream: any): DataInputStream
}

let DataInputStream: DataInputStreamModule = {
    def new(in) = extend(InputStream.new(in), in)
    def create(stream) = {
        val newstream =
	    primitive (0,
		       "java.io.DataInputStream",
		       "<init>",
		       "(Ljava/io/InputStream;)V")
		      (stream.toJava)
        extend(InputStream.new(newstream), newstream)
    }
    def extend(stream, in) = {
        with stream
        def readLine = primitive (2,
				  "java.io.DataInputStream",
				  "readLine",
				  "()Ljava/lang/String;")
				 (in)
        def readInt =
	    primitive (2, "java.io.DataInputStream", "readInt", "()I") (in)
        def readFloat =
	    primitive (2, "java.io.DataInputStream", "readFloat", "()F") (in)
        def readUTF =
	    primitive (2,
		       "java.io.DataInputStream",
		       "readUTF",
		       "()Ljava/lang/String;")
		      (in)
    }
}
